/*
 * Copyright (C) 2019 Zilliqa
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

/// [TODO] Currently unused

#ifndef ZILLIQA_SRC_LIBUTILS_REVERSELOCK_H_
#define ZILLIQA_SRC_LIBUTILS_REVERSELOCK_H_

template <class T>
class ReverseLock {
 public:
  ReverseLock(T& mutex) : mutex_(mutex) {
    if (mutex_.owns_lock()) {
      mutex_.unlock();
    }
  }

  ~ReverseLock() { mutex_.lock(); }

  ReverseLock(const ReverseLock&) = delete;
  ReverseLock& operator=(const ReverseLock&) = delete;

 private:
  T& mutex_;
};

#endif  // ZILLIQA_SRC_LIBUTILS_REVERSELOCK_H_
